#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "_listener4xi.py">
#<abstract4xi abstract = "providing services for the object _listener4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ace_listener4xi',            
            'reason_listener4xi',
            'sense_listener4xi',
            'reset_listener4xi',            
            'get_listener4xi',
            'set_listener4xi',
            'set_listener4xi',            
            'init_listener4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi   

import socket
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from current_process4xi import get_authkey_current_process4xi

from is_exiting4xi import is_exiting4xi

from listener4xi import Listener4Xi

from print4xi import print4xi

from sleep4xi import omega2sleep4xi
from send_handle4xi import send_handle4xi

from time4xi import time4xi

from _cache4xi import remove_cache4xi
from _lock4xi import release_lock4xi
from _lock4xi import acquire_lock4xi

#"
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global _listener4xi 
#"
#/>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "serve4xi" usage = "
#   embedded in this module
#   init_listener4xi:
#       thread2xi = threading.Thread(target=_serve4xi)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _serve4xi():
    '''
    thread to share handles
    '''
    
    # -----------------------------------------------------------------------------------------    
    # (Step 1/11)
    # -----------------------------------------------------------------------------------------        
      
    class2print = "_serve4xi"
    method2print = "_serve4xi"

    
    message2print = "{started" + "; serve4xi-started: " + str(_serve4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    # -----------------------------------------------------------------------------------------    
    # (Step 2/11)
    # -----------------------------------------------------------------------------------------        

    while 1:
    
        # -------------------------------------------------------------------------------------    
        # (Step 3/11)
        # -------------------------------------------------------------------------------------        
      
        try:
            message2print = "{(Step 3/11a) calling" + "; get_listener4xi: " + str(get_listener4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            
            # ---------------------------------------------------------------------------------    
            # 
            # ---------------------------------------------------------------------------------         
            ack2listener = False
            nack2listener = True
            
            try:         
                listener2xi = get_listener4xi() # dragonized, global variable _listener4xi is initialized, if its value is None
            
                message2print = "(Step 3/11b) set" + "; listener2xi-set-by-serve4xi to: " + str(listener2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
            
                ack2listener = True
                
                message2print = "(Step 3/11c) set" + "; ack2listener-set-by-serve4xi to: " + str(ack2listener)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                
            except:
                message2print = "{(Step 3/11d) yielded" + "; nack2listener-yielded-by-serve4xi: " + str(nack2listener)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
            
            
            # ---------------------------------------------------------------------------------    
            # 
            # ---------------------------------------------------------------------------------         
            ack2connection = False
            nack2connection = True
                           
            if ack2listener is True:
                
                try:                    
                    message2print = "{(Step 3/11e) calling" + "; listener2xi-accept-calling-by-serve4xi: " + str(listener2xi.accept) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)       
                                
                    connection2xi = listener2xi.accept()             
                                                                               
                    message2print = "{(Step 3/11f) set" + "; connection2xi-set-by-serve4xi to: " + str(connection2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                        
                    ack2connection = True
                        
                    message2print = "{(Step 3/11g) set" + "; ack2connection-set-by-serve4xi to: " + str(ack2connection)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                         
                        
                except:
                    message2print = "{(Step 3/11h) yielded" + "; nack2connection-yielded-by-serve4xi: " + str(nack2connection)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                  
            else:
                message2print = "{(Step 3/11f) yielded" + "; nack2connection-yielded-by-serve4xi: " + str(nack2connection)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                                                                     

               
             
            # ---------------------------------------------------------------------------------    
            # (Step 4/11)
            # ---------------------------------------------------------------------------------         
            ack2handle = False
            ack2pid = False
            nack2handle = True
            nack2pid = True
            
            if ack2connection is True:
            
                try:
                    message2print = "{(Step 4/11a) calling" + "; connection2xi-recv-calling-by-serve4xi: " + str(connection2xi.recv) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)       
                            
                     
                    handle_wanted2xi, destination_pid2xi = connection2xi.recv()
                    
                    message2print = "{(Step 4/11b) set" + "; handle-wanted2xi-set-by-serve4xi to: " + str(handle_wanted2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                                                                                                 
                    message2print = "{(Step 4/11c) set" + "; destination-pid2xi-set-by-serve4xi to: " + str(destination_pid2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    
                    ack2handle = True
                    
                    message2print = "{(Step 4/11d) set" + "; ack2handle-set-by-serve4xi to: " + str(ack2handle)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                                        
                    ack2pid = True

                    message2print = "{(Step 4/11e) set" + "; ack2pid-set-by-serve4xi to: " + str(ack2pid)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                    
                                                  
                except:
                    message2print = "{(Step 4/11f) yielded" + "; nack2handle-yielded-by-serve4xi: " + str(nack2handle)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                             
                    
                    message2print = "{(Step 4/11g) yielded" + "; nack2pid-yielded-by-serve4xi: " + str(nack2pid)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)               
            else:
                message2print = "{(Step 4/11h) yielded" + "; nack2handle-yielded-by-serve4xi: " + str(nack2handle)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                             
                
                message2print = "{(Step 4/11i) yielded" + "; nack2pid-yielded-by-serve4xi: " + str(nack2pid)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                   
             
            # ---------------------------------------------------------------------------------    
            # (Step 5/11)
            # ---------------------------------------------------------------------------------         
            ack2remove = False
            nack2remove = True
            
            if ack2handle is True:
                try:
                    message2print = "{(Step 5/11a) passing" + "; handle-wanted2xi-passing-to-remove-cache4xi-by-serve4xi: " + str(handle_wanted2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                
                             
                    remove_cache4xi(handle_wanted2xi)
                    
                    message2print = "{(Step 5/11b) performed" + "; remove-cache4xi-performed-by-serve4xi: " + str(remove_cache4xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    
                    ack2remove = True
                    
                    message2print = "{(Step 5/11c) set" + "; ack2remove-set-by-serve4xi to: " + str(ack2remove)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                
                                
                except:
                    message2print = "{(Step 5/11d) yielded" + "; nack2remove-yielded-by-serve4xi: " + str(nack2remove)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                   
            else:
                message2print = "{(Step 5/11e) yielded" + "; nack2remove-yielded-by-serve4xi: " + str(nack2remove)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                              
            # ---------------------------------------------------------------------------------    
            # (Step 6/11)
            # ---------------------------------------------------------------------------------         
            ack2send = False
            nack2send = True
            
            if ((ack2connection is True) and (ack2handle is True) and (ack2pid is True)):
                try:    
                    message2print = "{(Step 6/11a) passing" + "; connection2xi-passing-to-send-handle4xi-by-serve4xi: " + str(connection2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                
                    message2print = "{(Step 6/11b) passing" + "; handle-wanted2xi-passing-to-send-handle4xi-by-serve4xi: " + str(handle_wanted2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                        
                    
                    message2print = "{(Step 6/11c) passing" + "; destination-pid2xi-passing-to-send-handle4xi-by-serve4xi: " + str(destination_pid2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                                 
                    send_handle4xi(connection2xi, handle_wanted2xi, destination_pid2xi)
                    
                    message2print = "{(Step 6/11d) performed" + "; send-handle4xi-performed-by-serve4xi: " + str(send_handle4xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    
                    ack2send = True
                    
                    message2print = "{(Step 6/11e) set" + "; ack2send-set-by-serve4xi to: " + str(ack2send)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                         
                    
                                 
                except:
                    message2print = "{(Step 6/11f) yielded" + "; nack2send-yielded-by-serve4xi: " + str(nack2send)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                  
            else:
                 message2print = "{(Step 6/11g) yielded" + "; nack2send-yielded-by-serve4xi: " + str(nack2send)  + "; time: " + time4xi() + "}"
                 print4xi(class2print, method2print, message2print)                      
                                     
             
            # ---------------------------------------------------------------------------------    
            # (Step 7/11)
            # ---------------------------------------------------------------------------------         
            ack2close = False
            nack2close = True
            
            if ack2handle is True:
                try:
                    message2print = "{(Step 7/11a) passing" + "; handle-wanted2xi-passing-to-close4xi-by-serve4xi: " + str(handle_wanted2xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)          
                
                
                                 
                    close4xi(handle_wanted2xi)
                    
                    message2print = "{(Step 7/11b) performed" + "; close4xi-performed-by-serve4xi: " + str(close4xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    
                    ack2close = True 
                    
                    message2print = "{(Step 7/11c) set" + "; ack2close-set-by-serve4xi to: " + str(ack2close)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)   
                                                   
                except:
                    message2print = "{(Step 7/11d) yielded" + "; nack2close-yielded-by-serve4xi: " + str(nack2close)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                   
            else:
                message2print = "{(Step 7/11e) yielded" + "; nack2close-yielded-by-serve4xi: " + str(nack2close)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                              
             
            # ---------------------------------------------------------------------------------    
            # (Step 8/11)
            # ---------------------------------------------------------------------------------         
            ack2connectionclose = False
            nack2connectionclose = True
            
            if ack2connection is True:
                try:                         
                    connection2xi.close()
                    
                    message2print = "{(Step 8/11a) performed" + "; connection2xi-close-performed-by-serve4xi: " + str(connection2xi.close) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    
                    ack2connectionclose = True
                    
                    message2print = "{(Step 8/11b) set" + "; ack2connectionclose-set-by-serve4xi to: " + str(ack2connectionclose)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                       
                       
                except:
                    message2print = "{(Step 8/11c) yielded" + "; nack2connectionclose-yielded-by-serve4xi: " + str(nack2connectionclose)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
            else:        
                message2print = "{(Step 8/11d) yielded" + "; nack2connectionclose-yielded-by-serve4xi: " + str(nack2connectionclose)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
   
                            

        except:
                     
            # ---------------------------------------------------------------------------------    
            # (Step 9/11)
            # ---------------------------------------------------------------------------------         
            message2print = "{(Step 9/11a) calling" + "; is-exiting4xi-calling-by-serve4xi: " + str(is_exiting4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
                       
            
            if not is_exiting4xi():
             
                message2print = "{(Step 9/11b) hit" + "; thread-exception-hit-by-serve4xi: " + " *** thread for sharing handles raised exception *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                       
                    
            else:
             
                # -----------------------------------------------------------------------------    
                # (Step 10/11)
                #------------------------------------------------------------------------------         
                message2print = "{(Step 10/11) hit" + "; exception-hit-by-serve4xi: " + " *** _serve4xi raised exception *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)

            # ---------------------------------------------------------------------------------    
            #
            # ---------------------------------------------------------------------------------         
         
        # -------------------------------------------------------------------------------------    
        # 
        # -------------------------------------------------------------------------------------        
     
            
    # -----------------------------------------------------------------------------------------    
    # (Step 11/11)
    # -----------------------------------------------------------------------------------------                   
    message2print = "{(Step 11/11) returning" + "; serve4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                    
   
#</function4xi>


    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-listener4xi" usage = "
#   initializes _listener4xi
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def init_listener4xi():

    global _listener4xi 
    '''
    initializes global variable _listener4xi
    '''
    
    
    # -----------------------------------------------------------------------------------------    
    # (Step 1/7)
    # -----------------------------------------------------------------------------------------        
       
    class2print = "init_listener4xi"
    method2print = "init_listener4xi"

    
    message2print = "{started" + "; init-listener4xi-started: " + str(init_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
  
    acquire_lock4xi()
    
    message2print = "{(Step 2/7) performed" + "; acquire_lock4xi-performed-by-init-listener4xi: " + str(acquire_lock4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
            
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                 
    ack2listener = False
    nack2listener = True 
    
    try:
        # -------------------------------------------------------------------------------------    
        # (Step 3/7)
        # -------------------------------------------------------------------------------------                 
        ack2authkey = False
        nack2authkey = True
        
        try:
            authkey2xi = get_authkey_current_process4xi()  
            
            message2print = "{(Step 3/7a) got" + "; authkey2xi-got-by-init-listener4xi: " + str(authkey2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)

            ack2authkey = True
            
            message2print = "{(Step 3/7b) set" + "; ack2authkey-set-by-init-listener4xi to: " + str(ack2authkey)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
        except:
            message2print = "{(Step 3/7c) yielded" + "; nack2authkey-yielded-by-init-listener4xi: " + str(nack2authkey)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
        # -------------------------------------------------------------------------------------    
        # 
        # -------------------------------------------------------------------------------------                                             
        ack2listener = False
        nack2listener = True 
        
        if ack2authkey is True:
        
            try:
                message2print = "{(Step 3/7d) passing" + "; authkey2xi-passing-to-Listener4Xi-by-init-listener4xi: " + str(authkey2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)          
                        
                        
                _listener4xi = Listener4Xi(authkey2xi)                  #dragonized
                
                message2print = "{(Step 3/7e) got" + "; listener2xi-got-by-init-listener4xi: " + str(listener2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                                
                ack2listener = True        
        
                message2print = "{(Step 3/7f) set" + "; ack2listener-set-by-init-listener4xi to: " + str(ack2listener)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
            except:
                message2print = "{(Step 3/7g) yielded" + "; nack2listener-yielded-by-init-listener4xi: " + str(nack2listener)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
        else:
            message2print = "{(Step 3/7h) yielded" + "; nack2listener-yielded-by-init-listener4xi: " + str(nack2listener)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                  
        # -------------------------------------------------------------------------------------    
        # (Step 4/7)
        # -------------------------------------------------------------------------------------  
        ack2thread = False
        nack2thread = True
        
        try:
            message2print = "{(Step 4/7a) passing" + "; serve4xi-passing-to-threading-Thread-by-init-listener4xi: " + str(_serve4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
       
            message2print = "{(Step 4/7b) calling" + "; threading-Thread-calling-by-init-listener4xi: " + str(threading.Thread) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
                    
              
            thread2xi = threading.Thread(target=_serve4xi)            # dragonized 
            
            message2print = "{(Step 4/7c) got" + "; thread2xi-got-by-init-listener4xi: " + str(thread2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
   
            ack2thread = True     
        except:
            message2print = "{(Step 4/7d) yielded" + "; nack2thread-yielded-by-init-listener4xi: " + str(nack2thread)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            
                              
        # -------------------------------------------------------------------------------------    
        # (Step 5/7)
        # -------------------------------------------------------------------------------------                  
        ack2daemon = False
        nack2daemon = True
        
        if ack2thread is True:
            try:          
                thread2xi.daemon = True
                
                message2print = "{(Step 5/7a) set" + "; thread2xi-daemon-set-by-init-listener4xi to: " + str(thread2xi.daemon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                    
                ack2daemon = True
                
                message2print = "{(Step 5/7b) set" + "; ack2daemon-set-by-init-listener4xi to: " + str(ack2daemon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
                                
            except:
                message2print = "{(Step 4/7d) yielded" + "; nack2daemon-yielded-by-init-listener4xi: " + str(nack2daemon)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                
        else:
            message2print = "{(Step 4/7ed) yielded" + "; nack2daemon-yielded-by-init-listener4xi: " + str(nack2daemon)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
                
        # -------------------------------------------------------------------------------------    
        # (Step 6/7)
        # -------------------------------------------------------------------------------------                 
        ack2start = False
        nack2start = True
        
        if ack2thread is True:
            try:
                message2print = "{(Step 6/7a) starting" + "; thread2xi-start-starting: " + str(thread2xi.start)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                
                  
                thread2xi.start()
            
                omega2sleep4xi(class2print,method2print)
                
                ack2start = True
                
                message2print = "{(Step 6/7b) set" + "; ack2start-set-by-init-listener4xi to: " + str(ack2start)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                
            except:
                message2print = "{(Step 6/7c) yielded" + "; nack2start-yielded-by-init-listener4xi: " + str(nack2start)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
        else:
            message2print = "{(Step 6/7d) yielded" + "; nack2start-yielded-by-init-listener4xi: " + str(nack2start)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                     
    except:
        message2print = "{(Step 6/7b) yielded" + "; nack2listener-yielded-by-init-listener4xi: " + str(nack2listener)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
    
            
    # -----------------------------------------------------------------------------------------    
    # (Step 7/7)
    # -----------------------------------------------------------------------------------------                 
            
    finally:
        release_lock4xi()        #dragonixed
        
        message2print = "{(Step 7/7a) released" + "; lock4xi-released-by-init-listener4xi: " + str(release_lock4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)               
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    if ack2listener is True:
        message2print = "{(Step 7/7b) initialized" + "; listener4xi-initialized-by-init-listener4xi to: " + str(_listener4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    else:
        message2print = "{(Step 7/7b) yielded" + "; nack2listener-yielded-by-init-listener4xi: " + str(nack2listener)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
              
    message2print = "{(Step 7/7c) returning" + "; init-listener4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                  
#</function4xi>
  
# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-listener4xi" usage = "
#   sets listener
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def set_listener4xi(listener=None):

    global _listener4xi 
    '''
    sets listener
    ''' 
    
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
       
    class2print = "set_listener4xi"
    method2print = "set_listener4xi"
    
    message2print = "{started" + "; set-listener4xi-started: " + str(set_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    _listener4xi = init_listener4xi()        
    
        
    message2print = "{set" + "; listener4xi-set-by-set-listener4xi to: " + str(_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
               
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                   
    message2print = "{returning" + "; set-listener4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)         
#</function4xi>
              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-listener4xi" usage = "
#   returns _listener4xi
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def get_listener4xi():

    global _listener4xi 
    
    '''
    returns _listener4xi
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    
 
    class2print = "get_listener4xi"
    method2print = "get_listener4xi"
    
    message2print = "{started" + "; get-listener4xi-started: " + str(get_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------        
    if _listener4xi is None:
        init_listener4xi()   
    
    message2print = "{returning" + "; listener4xi-returning-by-get-listener4xi: " + str(_listener4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
    
  
            
    return _listener4xi
        
#</function4xi>
                      
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-listener4xi" usage = "
#   returns _listener4xi   
#">  
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _get_listener4xi():
    '''
    returns _listener4xi
    '''
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    
 
    class2print = "get_listener4xi" 
    method2print = "get_listener4xi"
    
    message2print = "{started" + "; get-listener4xi-started: " + str(get_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------        
    if _listener4xi is None:
        init_listener4xi()   
    
    message2print = "{returning" + "; listener4xi-returning-by-get-listener4xi: " + str(_listener4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
    
  
            
    return _listener4xi
    
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reset-listener4xi" usage = "
#   resets listener
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reset_listener4xi():

    global _listener4xi 
    '''
    resets listener
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
   
    class2print = "reset_listener4xi"
    method2print = "reset_listener4xi"
    
    message2print = "{started" + "; reset-listener4xi-started: " + str(reset_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
  
    
    _listener4xi = init_listener4xi()   

    message2print = "{reset" + "; listener4xi-reset-by-reset-listener4xi: " + str(_listener4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                   
    message2print = "{returning" + "; reset-listener4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense-listener4xi" usage = "
#   senses listener
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sense_listener4xi():

    global _listener4xi 
    '''
    senses _listener4xi
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    
 
    class2print = "sense_listener4xi"
    method2print = "sense_listener4xi"
    
    message2print = "{started" + "; sense-listener4xi-started: " + str(sense_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{sensing" + "; listener4xi-sensing-by-sense-listener4xi: " + str(_listener4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
            
    return _listener4xi
    
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reason-listener4xi" usage = "
#   reasons listener
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def reason_listener4xi():

    global _listener4xi 
    '''
    reasons _listener4xi
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    
 
    class2print = "reason_listener4xi"
    method2print = "reason_listener4xi"
    
    message2print = "{started" + "; reason-listener4xi-started: " + str(reason_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    if _listener4xi is None:
        message2print = "{reasoning" + "; listener4xi-reasoning-by-reason-listener4xi: no listener available; _listener4xi = " + str(_listener4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)       
    else:
        message2print = "{reasoning" + "; listener4xi-reasoning-by-reason-listener4xi: listener available; _listener4xi = " + str(_listener4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)          
        
    return _listener4xi  
#</function4xi>
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "ace-listener4xi" usage = "
#   aces listener
#"> 
#<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def ace_listener4xi(): 

    global _listener4xi 

    '''
    aces listener
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    class2print = "ace_listener4xi"
    method2print = "ace_listener4xi"
    
    message2print = "{started" + "; ace-listener4xi-started: " + str(ace_listener4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    if _listener4xi is None:
        message2print = "{acing" + "; listener4xi-acing-by-ace-listener4xi: *** no listener to ace; _listener4xi = " + str(_listener4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)       
    else:
        message2print = "{acing" + "; listener4xi-acing-by-ace-listener4xi: listener to be aced; _listener4xi = " + str(_listener4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)          
        
    return _listener4xi         
#</function4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_listener4xi.txt
#   sense-test-listener4xi.xml
#   reason-test-listener4xi.xml
#   ace-test-listener4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of _listener4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
